<template>
    <div class="text-center">
        <v-dialog v-model="dialog" width="650" v-if="isCurrentUserAllowed" ref="dialog">
            <template v-slot:activator="{ on, attrs }">
                <v-btn v-bind="attrs" v-on="on" outlined color="red" elevation="5"
                       class="ml-1 mr-1 white--text">
                    {{ $t('LNG_LESSON_DELETE') }}
                </v-btn>
            </template>
            <v-card>
                <v-card-title class="headline red">
                    <span class="headline white--text">{{ $t('LNG_LESSON_DELETE') }}</span>
                    <v-spacer></v-spacer>
                    <v-btn color="error" @click="closeDialog" fab small>
                        <v-icon color="white">mdi-close</v-icon>
                    </v-btn>
                </v-card-title>
                <v-card-text>
                    <p style="font-size: 1.2em" class="pt-3 mb-n2">{{ $t('LNG_LESSON_DELETE_QUESTION') }}</p>
                </v-card-text>
                <v-card-actions class="px-3">
                    <v-spacer></v-spacer>
                    <v-btn @click="closeDialog" color="grey" class="mr-4 white--text">
                        {{ $t('LNG_LESSON_DELETE_CANCEL') }}
                    </v-btn>
                    <v-btn @click="deleteLesson" color="error" class="mr-4">
                        {{ $t('LNG_LESSON_DELETE') }}
                    </v-btn>
                </v-card-actions>
                <v-card-text>
                    <p v-if="requestOK || requestFail"
                       :style="{ color: (requestOK) ? 'green' : 'red'}"
                       class="mt-1 mb-n2 text-right">
                        {{ message }}
                    </p>
                </v-card-text>
            </v-card>
        </v-dialog>
    </div>
</template>

<script>
import Services from "@/services/api/index"
import { SET_LESSONS } from "@/store/mutations.type";
import { mapGetters } from "vuex";

export default {
    name: 'LessonDelete',
    data: () => ({
        dialog: false,
        requestOK: false,
        requestFail: false,
        message: ""
    }),
    computed: {
        ...mapGetters([
            'user',
            'currentLessonId',
            'lessons'
        ]),
        isCurrentUserAllowed() {
            return this.user && (this.user.type === 'TEACHER' || this.user.type === 'ADMIN');
        }
    },
    methods: {
        deleteLesson() {
            // Get the current lesson data from the the store
            const currentLesson = this.lessons[this.currentLessonId];
            // Delete the current lesson using API and its ID
            Services.Lesson.deleteLesson(currentLesson.id)
                .then(res => {
                    // Manage returned HTTP code
                    this.manageHTTPCodeReturned(res.status);
                    // Update store if the deletion worked
                    if (res.status === 200) {
                        const fieldID = this.$route.params.id;
                        Services.Lesson.getLessonByField(fieldID)
                            .then(res => {
                                this.$store.commit(SET_LESSONS, res);
                            });
                    }
                })
        },
        // Display a message for the user with the returned HTTP code
        manageHTTPCodeReturned(code) {
            this.requestOK = false;
            this.requestFail = false;
            switch (code) {
                case 200:
                    this.requestOK = true;
                    this.message = this.$t("LNG_LESSON_DELETE_DELETED");
                    setTimeout(() => {
                        this.closeDialog();
                    }, 3000);
                    break;
                case 404:
                    this.$router.push('404 Not found');
                    break;
                default:
                    if (code >= 400 && code < 500) {
                        this.requestFail = true;
                        this.message = this.$t("LNG_LESSON_DELETE_CLIENTERROR") + " Code : " + code;
                    } else if (code >= 500 && code < 600) {
                        this.requestFail = true;
                        this.message = this.$t("LNG_LESSON_DELETE_SERVERERROR") + " Code : " + code;
                    } else {
                        this.requestFail = true;
                        this.message = this.$t("LNG_LESSON_DELETE_FAILED") + " Code : " + code
                    }
            }
        },
        closeDialog() {
            this.dialog = false;
            this.requestOK = false;
            this.requestFail = false;
            this.message = "";
        }
    }
}
</script>
